function [Train Train_classes Valid Valid_classes Test Test_classes] = ...
	divide_data(Data, Classes, validsize, testsize)

%
% create training, validation, and testing data sets
%

[n dim] = size(Data);

rand('state',sum(100*clock));

Inds       = randperm(n);
Test_inds  = Inds(1:testsize);                     % indices of test samples
Valid_inds = Inds(testsize+1:testsize+validsize);  % indices of validation samples
Train_inds = Inds(testsize+validsize+1:end);       % indices of train samples
  
Train         = Data(Train_inds, :);    % training data
Train_classes = Classes(Train_inds);    % corresponding classes

Valid         = Data(Valid_inds, :);    % validation data
Valid_classes = Classes(Valid_inds, :); % corresponding classes

Test          = Data(Test_inds, :);     % test data
Test_classes  = Classes(Test_inds);     % corresponding classes
