function save_svm_data(Train, Test, Train_classes, Test_classes, method, no)

[ntrain dim] = size(Train);
[ntest dim]  = size(Test);

Str_train = sprintf('train_%s_%d.txt', method, no);
Str_test  = sprintf('test_%s_%d.txt', method, no);

M = mean(Train);
S = std(Train);

S(S==0)  = realmax; % if the variance of some variable is zero,
                    % ignore the variable

Train = (Train - ones(ntrain, 1) * M)./(ones(ntrain, 1) * S); % normalize train data
Test  = (Test - ones(ntest,1) * M)./(ones(ntest, 1)* S );     % normalize test data

Train_classes = 2 * (Train_classes - 1.5);
Test_classes  = 2 * (Test_classes - 1.5);

Temp = [Train Train_classes];
save(Str_train, '-ASCII', 'Temp');

Temp = [Test Test_classes];
save(Str_test, '-ASCII', 'Temp');
