function [Vars_best, Vars_best_err, Vars_worst, Vars_worst_err] = ...
    sbs(Data, Classes, Selected, repeat, validsize, testsize, K, no)

%
% sequential backward selection
%

[n dim]        = size(Data);
sel            = length(Selected);
Vars_best      = zeros(no, 1);
Vars_best_err  = zeros(no, 1);
Vars_worst     = zeros(no, 1);
Vars_worst_err = zeros(no, 1);

for i = 1:no

  E = zeros(length(Selected), 1);

  for j = 1:length(Selected)

    Features = Data(:, Selected(Selected(j)==[]));

    e = 0;
    for r = 1:repeat
      [Train Train_classes Valid Valid_classes Test Test_classes] = ...
          divide_data(Features, Classes, validsize, testsize);

      k      = select_k(Train, Train_classes, Valid, Valid_classes, K);
    
      Result = kNN(Train, Train_classes, Test, k);

      e      = e + sum(Result ~= Test_classes);
    end

    E(j) = e;
  end
  
  [best_err best_ind]   = min(E);
  Vars_best_err(i)      = best_err/(repeat * testsize);
  Vars_best(i)          = Selected(best_ind);

  [worst_err worst_ind] = max(E);
  Vars_worst_err(i)     = worst_err/(repeat * testsize);
  Vars_worst(i)         = Selected(worst_ind); 
  
  Selected(best_ind)    = [];

end

