function [Vars, Err] = sfs(Data, Classes, Selected, repeat, validsize, ...
                           testsize, K, no)

%
% sequential forward selection
%

[n dim] = size(Data);
Vars    = zeros(no, 1);
Err     = zeros(no, 1);

for i = 1:no

  Unselected = setdiff(1:dim, Selected);
  E          = zeros(length(Unselected), 1);

  for j = 1:length(Unselected)

    Features = Data(:, [Selected; Unselected(j)]);
    
    e = 0;
    for r = 1:repeat
      [Train Train_classes Valid Valid_classes Test Test_classes] = ...
          divide_data(Features, Classes, validsize, testsize);

      k      = select_k(Train, Train_classes, Valid, Valid_classes, K);
    
      Result = kNN(Train, Train_classes, Test, k);

      e      = e + sum(Result ~= Test_classes);
    end

    E(j) = e;
  end

  [err ind] = min(E);
  Err(i)    = err/(repeat * testsize);
  Vars(i)   = Unselected(ind);
  Selected  = [Selected; Vars(i)];

end
